#pragma once

#include <string>

////////////////////////////////////////////////////////////////////////
// i\EBhE
////////////////////////////////////////////////////////////////////////

class CProgressDlg
{
public:
	// RXgN^
	CProgressDlg(int stepMax, const char* caption);
	// fXgN^
	virtual ~CProgressDlg();

public:
	// EBhE\ 
	bool DoModeless(HWND hWndParent);
	// i\
	void StepIt();
	// I\
	void TerminateStep(const char* progressMsg);
	// LZꂽ𓾂
	bool IsCancel();
	// I
	void EndDialog();

private:
	// _CAOvV[W(]p)
	static BOOL CALLBACK DialogProcStatic(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// _CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_CLOSE nh
	void OnClose(HWND hwnd);

private:
	// i\
	void SetStep(int step);
	// LZ
	void Cancel();
	// EBhEj
	void Destory();
	// Cxg[v
	void DoEvents();

private:
	// Xebvl
	int m_step;
	// Xebv̍ől
	int m_stepMax;
	// _CAOnh
	HWND m_hDlg;
	// eEBhẼnh
	HWND m_hWndParent;
	// _CAÕLvV
	std::string m_caption;
	// LZꂽ̃tO
	bool m_bCancel;

private:
	// g̃CX^X
	static CProgressDlg* s_pThis;
};

